/* psc96.c -- Cenju-3 */

#include <stdio.h>
#include <math.h>
#include <mpi.h>
#include "fft.h"

typedef struct {
    int i;
    complex X;
} sendmax;

static int cid;

double* W;
complex* y;
complex* x;
complex* X;
int* ep;

complex get_w(int,int);

main()
{
    int i,j,k,l,m,n,b,p,q,e,r;
    int vid;
    int idx[8];
    double t,dt,sum;
    double max1,max2;
    int i1,i2;
    complex w,z;
    complex *bufs;
    complex *bufd;
    complex r0,r1,r2,r3;
    complex v[9],u[8],s[5];
    double d;
    sendmax sm;
    complex amax[2];
    int index[2];
    int npe;
    MPI_Status status;

    W = (double *)malloc((N/4+1) * sizeof(complex));
    y = (complex *)malloc(N_PE * sizeof(complex));
    x = (complex *)malloc(N_PE * sizeof(complex));
    X = (complex *)malloc(N_PE * sizeof(complex));
    ep = (int *)malloc(N_PE/5 * sizeof(int));

    f_init();

    mpi_set_nr(NumberOfCell) ;
    MPI_Init() ;

    MPI_Comm_rank( MPI_COMM_WORLD , &cid ) ;
    MPI_Comm_size( MPI_COMM_WORLD , &npe ) ;

    if ( npe != NumberOfCell ){
	if ( cid == 0 ) printf("Cannot allocate %d PEs.\n",NumberOfCell);
	MPI_Finalize();
	exit();
    }

    MPI_Barrier(MPI_COMM_WORLD);

    /* W η׻ */
    dt = 2.0 * PI / (double)N;
    for (i = 0 ; i <= N/4 ; i++) {
	t = dt * (double)i;
	W[i] = sin(t);
    }
    idx[0]=0; idx[1]=4; idx[2]=2; idx[3]=6;
    idx[4]=1; idx[5]=5; idx[6]=3; idx[7]=7;

    generate(x,N_PE);

    for (i = 0 ; i < N_PE ; i++) {
	y[i] = x[i];
    }

    p = N; q = NumberOfCell / 2; n = 1; e = 0;
    for (k = 0 ; k < 7 ; k++) {		/* ʤο */
	if (k % 2 == 0) {
	    bufs = y; bufd = X;
	} else {
	    bufs = X; bufd = y;
	}

	/* N_PEĤΥǡȾʬ */
	if ((int)(cid / q) % 2 == 0) {
	    MPI_Send(&bufs[N_PE/2],N_PE/2,MPI_DOUBLE,cid+q,0,MPI_COMM_WORLD);
	    MPI_Recv(&bufs[N_PE/2],N_PE/2,MPI_DOUBLE,cid+q,0,MPI_COMM_WORLD,&status);
	    MPI_Send(&bufs[N_PE*3/4],N_PE/2,MPI_DOUBLE,cid+q,0,MPI_COMM_WORLD);
	    MPI_Recv(&bufs[N_PE*3/4],N_PE/2,MPI_DOUBLE,cid+q,0,MPI_COMM_WORLD,&status);
	} else {
	    MPI_Send(bufs,N_PE/2,MPI_DOUBLE,cid-q,0,MPI_COMM_WORLD);
	    MPI_Recv(bufs,N_PE/2,MPI_DOUBLE,cid-q,0,MPI_COMM_WORLD,&status);
	    MPI_Send(&bufs[N_PE/4],N_PE/2,MPI_DOUBLE,cid-q,0,MPI_COMM_WORLD);
	    MPI_Recv(&bufs[N_PE/4],N_PE/2,MPI_DOUBLE,cid-q,0,MPI_COMM_WORLD,&status);
	}

	e += ((cid / q) % 2) * n / 2;
	for (i = 0 ; i < N_PE / 2 ; i++) {	/* PEȹ礻ο */
	    w = get_w(2*n,e);
	    z.re = w.re * bufs[i+N_PE/2].re - w.im * bufs[i+N_PE/2].im;
	    z.im = w.re * bufs[i+N_PE/2].im + w.im * bufs[i+N_PE/2].re;
	    bufd[i].re = bufs[i].re + z.re;
	    bufd[i].im = bufs[i].im + z.im;
	    bufd[i+N_PE/2].re = bufs[i].re - z.re;
	    bufd[i+N_PE/2].im = bufs[i].im - z.im;
	}
	p /= 2;
	q /= 2;
	n *= 2;
    }

    /* N_PEĤΥǡȾʬ */
    q = NumberOfCell / 2;
    if ((int)(cid / q) % 2 == 0) {
	MPI_Send(&X[N_PE/2],N_PE/2,MPI_DOUBLE,cid+q,0,MPI_COMM_WORLD);
	MPI_Recv(&X[N_PE/2],N_PE/2,MPI_DOUBLE,cid+q,0,MPI_COMM_WORLD,&status);
	MPI_Send(&X[N_PE*3/4],N_PE/2,MPI_DOUBLE,cid+q,0,MPI_COMM_WORLD);
	MPI_Recv(&X[N_PE*3/4],N_PE/2,MPI_DOUBLE,cid+q,0,MPI_COMM_WORLD,&status);
    } else {
	MPI_Send(X,N_PE/2,MPI_DOUBLE,cid-q,0,MPI_COMM_WORLD);
	MPI_Recv(X,N_PE/2,MPI_DOUBLE,cid-q,0,MPI_COMM_WORLD,&status);
	MPI_Send(&X[N_PE/4],N_PE/2,MPI_DOUBLE,cid-q,0,MPI_COMM_WORLD);
	MPI_Recv(&X[N_PE/4],N_PE/2,MPI_DOUBLE,cid-q,0,MPI_COMM_WORLD,&status);
    }

    /* Ҿ ep η׻ */
    ep[0] = e;
    if (cid >= NumberOfCell / 2) {
	ep[0] += NumberOfCell / 2;
    }

    m = 1;
    for (k = 0 ; k < 1 ; k++) {	/* ʤο */
	p /= 2; b = 0;
	for (j = 0 ; j < m ; j++) {	/* ʤȢο */
	    for (i = 0 ; i < p ; i++) {	/* Ȣȹ礻ο */
		w = get_w(2*n,ep[j]);
		z.re = w.re * X[b+i+p].re - w.im * X[b+i+p].im;
		z.im = w.re * X[b+i+p].im + w.im * X[b+i+p].re;
		y[b+i].re = X[b+i].re + z.re;
		y[b+i].im = X[b+i].im + z.im;
		y[b+i+p].re = X[b+i].re - z.re;
		y[b+i+p].im = X[b+i].im - z.im;
	    }
	    b += 2 * p;
	}

	/* Ҿ ep */
	for (i = m - 1 ; i >= 0 ; i--) {
	    ep[i*2] = ep[i];
	    ep[i*2+1] = ep[i*2] + n;
	}
	n *= 2;
	m *= 2;
    }

    for (k = 0 ; k < 3 ; k++) {	/* ʤο */
	if (k % 2 == 0) {
	    bufs = y; bufd = X;
	} else {
	    bufs = X; bufd = y;
	}

	p /= 8; b = 0;
	for (j = 0 ; j < m ; j++) {	/* ʤȢο */
	    for (i = 0 ; i < p ; i++) {	/* Ȣȹ礻ο */
		/* 8  WFT η׻ */

		/* w */
		for (r = 1 ; r < 8 ; r++) {
		    w = get_w(8*n,ep[j]*r);
		    d = bufs[b+i+p*r].re * w.re - bufs[b+i+p*r].im * w.im;
		    bufs[b+i+p*r].im = bufs[b+i+p*r].im * w.re + bufs[b+i+p*r].re * w.im;
		    bufs[b+i+p*r].re = d;
		}

		/* v[1]v[8] ׻ */
		v[1].re = bufs[b+i].re + bufs[b+i+4*p].re;	v[1].im = bufs[b+i].im + bufs[b+i+4*p].im;
		v[2].re = bufs[b+i+2*p].re + bufs[b+i+6*p].re;	v[2].im = bufs[b+i+2*p].im + bufs[b+i+6*p].im;
		v[3].re = bufs[b+i+p].re + bufs[b+i+5*p].re;	v[3].im = bufs[b+i+p].im + bufs[b+i+5*p].im;
		v[4].re = bufs[b+i+p].re - bufs[b+i+5*p].re;	v[4].im = bufs[b+i+p].im - bufs[b+i+5*p].im;
		v[5].re = bufs[b+i+3*p].re + bufs[b+i+7*p].re;	v[5].im = bufs[b+i+3*p].im + bufs[b+i+7*p].im; 
		v[6].re = bufs[b+i+3*p].re - bufs[b+i+7*p].re;	v[6].im = bufs[b+i+3*p].im - bufs[b+i+7*p].im;
		v[7].re = v[1].re + v[2].re;	v[7].im = v[1].im + v[2].im;
		v[8].re = v[3].re + v[5].re;	v[8].im = v[3].im + v[5].im;
		/* u[0]u[7] ׻ */
		u[0].re = v[7].re + v[8].re;		u[0].im = v[7].im + v[8].im;
		u[1].re = v[7].re - v[8].re;		u[1].im = v[7].im - v[8].im;
		u[2].re = v[1].re - v[2].re;		u[2].im = v[1].im - v[2].im;
		u[3].re = bufs[b+i].re - bufs[b+i+4*p].re;	u[3].im = bufs[b+i].im - bufs[b+i+4*p].im;
		u[4].re = v[4].re - v[6].re;		u[4].im = v[4].im - v[6].im;
		u[5].re = v[3].re - v[5].re;		u[5].im = v[3].im - v[5].im;
		u[6].re = bufs[b+i+2*p].re - bufs[b+i+6*p].re;	u[6].im = bufs[b+i+2*p].im - bufs[b+i+6*p].im;
		u[7].re = v[4].re + v[6].re;		u[7].im = v[4].im + v[6].im; 
		/* u[4] = u[4] * cos(2/8) */ 
		u[4].re = u[4].re * 0.70710678118654757;	u[4].im = u[4].im * 0.70710678118654757;
		/* u[5] = - i * u[5] */
		d = u[5].re;	u[5].re = u[5].im;	u[5].im = - d;
		/* u[6] = - i * u[6] */
		d = u[6].re;	u[6].re = u[6].im;	u[6].im = - d;
		/* u[7] = -i sin(2/8) * u[7] */
		d = u[7].re;	u[7].re = 0.70710678118654757 * u[7].im;	u[7].im = - 0.70710678118654757 * d;
		/* s[1]s[4] ׻ */
		s[1].re = u[3].re + u[4].re;	s[1].im = u[3].im + u[4].im;
		s[2].re = u[3].re - u[4].re;	s[2].im = u[3].im - u[4].im;
		s[3].re = u[6].re + u[7].re;	s[3].im = u[6].im + u[7].im;
		s[4].re = u[6].re - u[7].re;	s[4].im = u[6].im - u[7].im;

		bufd[b+i].re = u[0].re;			bufd[b+i].im = u[0].im;
		bufd[b+i+p].re = u[1].re;		bufd[b+i+p].im = u[1].im;
		bufd[b+i+2*p].re = u[2].re + u[5].re;	bufd[b+i+2*p].im = u[2].im + u[5].im;
		bufd[b+i+3*p].re = u[2].re - u[5].re;	bufd[b+i+3*p].im = u[2].im - u[5].im;
		bufd[b+i+4*p].re = s[1].re + s[3].re;	bufd[b+i+4*p].im = s[1].im + s[3].im;
		bufd[b+i+5*p].re = s[2].re + s[4].re;	bufd[b+i+5*p].im = s[2].im + s[4].im;
		bufd[b+i+6*p].re = s[2].re - s[4].re;	bufd[b+i+6*p].im = s[2].im - s[4].im;
		bufd[b+i+7*p].re = s[1].re - s[3].re;	bufd[b+i+7*p].im = s[1].im - s[3].im;
	    }
	    b += 8 * p;
	}

	/* Ҿ ep */
	for (i = m - 1 ; i >= 0 ; i--) {
	    ep[i*8] = ep[i];
	    ep[i*8+1] = ep[i*8] + n * 4;
	    ep[i*8+2] = ep[i*8] + n * 2;
	    ep[i*8+3] = ep[i*8] + n * 6;
	    ep[i*8+4] = ep[i*8] + n;
	    ep[i*8+5] = ep[i*8] + n * 5;
	    ep[i*8+6] = ep[i*8] + n * 3;
	    ep[i*8+7] = ep[i*8] + n * 7;
	}
	n *= 8;
	m *= 8;
    }

    for (k = 0 ; k < N5_PE ; k++) {	/* ʤο */
	if (k % 2 == 1) {
	    bufs = y; bufd = X;
	} else {
	    bufs = X; bufd = y;
	}

	p /= 5; b = 0;
	for (j = 0 ; j < m ; j++) {	/* ʤȢο */
	    for (i = 0 ; i < p ; i++) {	/* Ȣȹ礻ο */
		/* 5  WFT ׻ */

		/* w */
		for (r = 1 ; r < 5 ; r++) {
		    w = get_w(5*n,ep[j]*r);
		    d = bufs[b+i+p*r].re * w.re - bufs[b+i+p*r].im * w.im;
		    bufs[b+i+p*r].im = bufs[b+i+p*r].im * w.re + bufs[b+i+p*r].re * w.im;
		    bufs[b+i+p*r].re = d;
		}

		/* r0  r3 ׻ */
		/* r0 = (W1 + W2 + W4 + W3) (x[1] + x[2] + x[3] + x[4]) */
		r0.re = - bufs[b+i+p].re -  bufs[b+i+2*p].re - bufs[b+i+3*p].re - bufs[b+i+4*p].re;
		r0.im = - bufs[b+i+p].im -  bufs[b+i+2*p].im - bufs[b+i+3*p].im - bufs[b+i+4*p].im;
		/* r1 = (W1 - W2 + W4 - W3 ) (x[1] - x[2] - x[3] + x[4]) */
		r1.re = 2.236067977418423 * (bufs[b+i+p].re - bufs[b+i+2*p].re - bufs[b+i+3*p].re + bufs[b+i+4*p].re);
		r1.im = 2.236067977418423 * (bufs[b+i+p].im - bufs[b+i+2*p].im - bufs[b+i+3*p].im + bufs[b+i+4*p].im);
		/* r2 = (W1 - W4) (x[1] - x[4]) - (W2 - W3) (x[3] - x[2]) */ 
		r2.re = - 1.902113032623604 * (bufs[b+i+p].im - bufs[b+i+4*p].im) + 1.175570504555888 * (bufs[b+i+3*p].im - bufs[b+i+2*p].im);
		r2.im = 1.902113032623604 * (bufs[b+i+p].re - bufs[b+i+4*p].re) - 1.175570504555888 * (bufs[b+i+3*p].re - bufs[b+i+2*p].re);
		/* r3 = (W1 - W4) (x[3] - x[2]) + (W2 - W3) (x[1] - x[4]) */
		r3.re = - 1.902113032623604 * (bufs[b+i+3*p].im - bufs[b+i+2*p].im) - 1.175570504555888 * (bufs[b+i+p].im - bufs[b+i+4*p].im);
		r3.im = 1.902113032623604 * (bufs[b+i+3*p].re - bufs[b+i+2*p].re) + 1.175570504555888 * (bufs[b+i+p].re - bufs[b+i+4*p].re);

		/* X0 = x0 + x1 + x2 + x3 + x4 = x0 - r0 */
		bufd[b+i].re = bufs[b+i].re - r0.re;
		bufd[b+i].im = bufs[b+i].im - r0.im;
		/* X2 = (r0 - r1 - 2*r3) / 4 + x0 */
		r3.re *= 2.0;	r3.im *= 2.0;
		bufd[b+i+2*p].re = (r0.re - r1.re - r3.re) / 4.0 + bufs[b+i].re;
		bufd[b+i+2*p].im = (r0.im - r1.im - r3.im) / 4.0 + bufs[b+i].im;
		/* X1 = (r0 + r1 - 2*r2) / 4 + x0 */
		r2.re *= 2.0;	r2.im *= 2.0;
		bufd[b+i+p].re = (r0.re + r1.re - r2.re) / 4.0 + bufs[b+i].re;
		bufd[b+i+p].im = (r0.im + r1.im - r2.im) / 4.0 + bufs[b+i].im;
		/* X3 = (r0 - r1 + 2*r3) / 4 + x0 */
		bufd[b+i+3*p].re = (r0.re - r1.re + r3.re) / 4.0 + bufs[b+i].re;
		bufd[b+i+3*p].im = (r0.im - r1.im + r3.im) / 4.0 + bufs[b+i].im;
		/* X4 = (r0 + r1 + 2*r2) / 4.0 + x0 */
		bufd[b+i+4*p].re = (r0.re + r1.re + r2.re) / 4.0 + bufs[b+i].re;
		bufd[b+i+4*p].im = (r0.im + r1.im + r2.im) / 4.0 + bufs[b+i].im;
	    }
	    b += 5 * p;
	}

	/* Ҿ ep */
	if (k < N5_PE - 1) {
	    for (i = m - 1 ; i >= 0 ; i--) {
		ep[i*5] = ep[i];
		ep[i*5+1] = ep[i*5] + n;
		ep[i*5+2] = ep[i*5] + n * 2;
		ep[i*5+3] = ep[i*5] + n * 3;
		ep[i*5+4] = ep[i*5] + n * 4;
	      }
	}
	m *= 5;
	n *= 5;
    }

    /* ͤκ */
    max1 = -1.0;
    max2 = -1.0;
    for (i = 0 ; i < N_PE ; i++) {
	t = X[i].re * X[i].re + X[i].im * X[i].im;
	if (t > max1) {
            max2 = max1; i2 = i1;
            max1 = t; i1 = i;
        } else if (t > max2) {
            max2 = t; i2 = i;
        }
    }
    MPI_Allreduce(&max1,&t,1,MPI_DOUBLE,MPI_MAX, MPI_COMM_WORLD);
    if (max1 == t) {
	n = (cid % (NumberOfCell / 2)) * 2;
	if (cid >= NumberOfCell / 2) {
	    n++;
	}
	sm.i = i1 + n * N_PE;
	/* ѹ */
	n = 1; p = N;
	for (k = 0 ; k < N5 ; k++) {	/* ʤο */
	    n *= 5; p /= 5;
	    j = sm.i % 5;
	    i = (sm.i - j) / 5;
	    j += i / p * 5;
	    i = i % p;
	    sm.i = j*p+i;
	}
	for (k = 0 ; k < N2 ; k++) {	/* ʤο */
	    n *= 2; p /= 2;
	    j = sm.i % 2;
	    i = (sm.i - j) / 2;
	    j += i / p * 2;
	    i = i % p;
	    sm.i = j*p+i;
	}
	amax[0] = X[i1];
	index[0] = sm.i;
	max1 = max2; i1 = i2;
    } else {
	amax[0].re = amax[0].im = 0.0;
	index[0] = 0;
    }
    MPI_Allreduce(&max1,&t,1,MPI_DOUBLE,MPI_MAX, MPI_COMM_WORLD);
    if (max1 == t) {
	n = (cid % (NumberOfCell / 2)) * 2;
	if (cid >= NumberOfCell / 2) {
	    n++;
	}
	sm.i = i1 + n * N_PE;
	/* ѹ */
	n = 1; p = N;
	for (k = 0 ; k < N5 ; k++) {	/* ʤο */
	    n *= 5; p /= 5;
	    j = sm.i % 5;
	    i = (sm.i - j) / 5;
	    j += i / p * 5;
	    i = i % p;
	    sm.i = j*p+i;
	}
	for (k = 0 ; k < N2 ; k++) {	/* ʤο */
	    n *= 2; p /= 2;
	    j = sm.i % 2;
	    i = (sm.i - j) / 2;
	    j += i / p * 2;
	    i = i % p;
	    sm.i = j*p+i;
	}
	amax[1] = X[i1];
	index[1] = sm.i;
    } else {
	amax[1].re = amax[1].im = 0.0;
	index[1] = 0;
    }
    MPI_Allreduce(amax,amax,4,MPI_DOUBLE,MPI_SUM, MPI_COMM_WORLD);
    MPI_Allreduce(index,index,2,MPI_INT,MPI_SUM, MPI_COMM_WORLD);
    check(amax,index);

    /* in case to calculate Inverse FFT */
	/* Ѵ */
	p = 1; n = N; m = N_PE;
	for (k = 0 ; k < N5_PE ; k++) {	/* ʤο */
	    if (k % 2 == 1) {
		bufs = y; bufd = X;
	    } else {
		bufs = X; bufd = y;
	    }

	    n /= 5; m /= 5; b = 0;
	    for (j = 0 ; j < m ; j++) {	/* ʤȢο */
		for (i = 0 ; i < p ; i++) {	/* Ȣȹ礻ο */
		    /* w */
		    if (i > 0) {
			for (r = 1 ; r < 5 ; r++) {
			    w = get_w(5*p,i*r);
			    d = bufs[b+i+p*r].re * w.re + bufs[b+i+p*r].im * w.im;
			    bufs[b+i+p*r].im = bufs[b+i+p*r].im * w.re - bufs[b+i+p*r].re * w.im;
			    bufs[b+i+p*r].re = d;
			}
		    }

		    /* r0  r3 ׻ */
		    /* r0 = (W1 + W2 + W4 + W3) (x[1] + x[2] + x[3] + x[4]) */
		    r0.re = - bufs[b+i+p].re -  bufs[b+i+2*p].re - bufs[b+i+3*p].re - bufs[b+i+4*p].re;
		    r0.im = - bufs[b+i+p].im -  bufs[b+i+2*p].im - bufs[b+i+3*p].im - bufs[b+i+4*p].im;
		    /* r1 = (W1 - W2 + W4 - W3 ) (x[1] - x[2] - x[3] + x[4]) */
		    r1.re = 2.236067977418423 * (bufs[b+i+p].re - bufs[b+i+2*p].re - bufs[b+i+3*p].re + bufs[b+i+4*p].re);
		    r1.im = 2.236067977418423 * (bufs[b+i+p].im - bufs[b+i+2*p].im - bufs[b+i+3*p].im + bufs[b+i+4*p].im);
		    /* r2 = (W1 - W4) (x[1] - x[4]) - (W2 - W3) (x[3] - x[2]) */ 
		    r2.re = 1.902113032623604 * (bufs[b+i+p].im - bufs[b+i+4*p].im) - 1.175570504555888 * (bufs[b+i+3*p].im - bufs[b+i+2*p].im);
		    r2.im = - 1.902113032623604 * (bufs[b+i+p].re - bufs[b+i+4*p].re) + 1.175570504555888 * (bufs[b+i+3*p].re - bufs[b+i+2*p].re);
		    /* r3 = (W1 - W4) (x[3] - x[2]) + (W2 - W3) (x[1] - x[4]) */
		    r3.re = 1.902113032623604 * (bufs[b+i+3*p].im - bufs[b+i+2*p].im) + 1.175570504555888 * (bufs[b+i+p].im - bufs[b+i+4*p].im);
		    r3.im = - 1.902113032623604 * (bufs[b+i+3*p].re - bufs[b+i+2*p].re) - 1.175570504555888 * (bufs[b+i+p].re - bufs[b+i+4*p].re);

		    /* X0 = x0 + x1 + x2 + x3 + x4 = x0 - r0 */
		    bufd[b+i].re = bufs[b+i].re - r0.re;
		    bufd[b+i].im = bufs[b+i].im - r0.im;
		    /* X2 = (r0 - r1 - 2*r3) / 4 + x0 */
		    r3.re *= 2.0;    r3.im *= 2.0;
		    bufd[b+i+2*p].re = (r0.re - r1.re - r3.re) / 4.0 + bufs[b+i].re;
		    bufd[b+i+2*p].im = (r0.im - r1.im - r3.im) / 4.0 + bufs[b+i].im;
		    /* X1 = (r0 + r1 - 2*r2) / 4 + x0 */
		    r2.re *= 2.0;    r2.im *= 2.0;
		    bufd[b+i+p].re = (r0.re + r1.re - r2.re) / 4.0 + bufs[b+i].re;
		    bufd[b+i+p].im = (r0.im + r1.im - r2.im) / 4.0 + bufs[b+i].im;
		    /* X3 = (r0 - r1 + 2*r3) / 4 + x0 */
		    bufd[b+i+3*p].re = (r0.re - r1.re + r3.re) / 4.0 + bufs[b+i].re;
		    bufd[b+i+3*p].im = (r0.im - r1.im + r3.im) / 4.0 + bufs[b+i].im;
		    /* X4 = (r0 + r1 + 2*r2) / 4.0 + x0 */
		    bufd[b+i+4*p].re = (r0.re + r1.re + r2.re) / 4.0 + bufs[b+i].re;
		    bufd[b+i+4*p].im = (r0.im + r1.im + r2.im) / 4.0 + bufs[b+i].im;
		}
		b += 5 * p;
	    }
	    p *= 5;
	}

	for (k = 0 ; k < 3 ; k++) {	/* ʤο */
	    if (k % 2 == 1) {
		bufs = y; bufd = X;
	    } else {
		bufs = X; bufd = y;
	    }

	    n /= 8; m /= 8; b = 0;
	    for (j = 0 ; j < m ; j++) {	/* ʤȢο */
		for (i = 0 ; i < p ; i++) {	/* Ȣȹ礻ο */
		    /* w */
		    if (i > 0) {
			for (r = 1 ; r < 8 ; r++) {
			    w = get_w(8*p,i*idx[r]);
			    d = bufs[b+i+p*r].re * w.re + bufs[b+i+p*r].im * w.im;
			    bufs[b+i+p*r].im = bufs[b+i+p*r].im * w.re - bufs[b+i+p*r].re * w.im;
			    bufs[b+i+p*r].re = d;
			}
		    }

		    /* v[1]v[8] ׻ */
		    v[1].re = bufs[b+i].re + bufs[b+i+p].re;	v[1].im = bufs[b+i].im + bufs[b+i+p].im;
		    v[2].re = bufs[b+i+2*p].re + bufs[b+i+3*p].re;	v[2].im = bufs[b+i+2*p].im + bufs[b+i+3*p].im;
		    v[3].re = bufs[b+i+4*p].re + bufs[b+i+5*p].re;	v[3].im = bufs[b+i+4*p].im + bufs[b+i+5*p].im;
		    v[4].re = bufs[b+i+4*p].re - bufs[b+i+5*p].re;	v[4].im = bufs[b+i+4*p].im - bufs[b+i+5*p].im;
		    v[5].re = bufs[b+i+6*p].re + bufs[b+i+7*p].re;	v[5].im = bufs[b+i+6*p].im + bufs[b+i+7*p].im; 
		    v[6].re = bufs[b+i+6*p].re - bufs[b+i+7*p].re;	v[6].im = bufs[b+i+6*p].im - bufs[b+i+7*p].im;
		    v[7].re = v[1].re + v[2].re;	v[7].im = v[1].im + v[2].im;
		    v[8].re = v[3].re + v[5].re;	v[8].im = v[3].im + v[5].im;
		    /* u[0]u[7] ׻ */
		    u[0].re = v[7].re + v[8].re;		u[0].im = v[7].im + v[8].im;
		    u[1].re = v[7].re - v[8].re;		u[1].im = v[7].im - v[8].im;
		    u[2].re = v[1].re - v[2].re;		u[2].im = v[1].im - v[2].im;
		    u[3].re = bufs[b+i].re - bufs[b+i+p].re;	u[3].im = bufs[b+i].im - bufs[b+i+p].im;
		    u[4].re = v[4].re - v[6].re;		u[4].im = v[4].im - v[6].im;
		    u[5].re = v[3].re - v[5].re;		u[5].im = v[3].im - v[5].im;
		    u[6].re = bufs[b+i+2*p].re - bufs[b+i+3*p].re;	u[6].im = bufs[b+i+2*p].im - bufs[b+i+3*p].im;
		    u[7].re = v[4].re + v[6].re;		u[7].im = v[4].im + v[6].im; 
		    /* u[4] = u[4] * cos(2/8) */ 
		    u[4].re = u[4].re * 0.70710678118654757;	u[4].im = u[4].im * 0.70710678118654757;
		    /* u[5] = - i * u[5] */
		    d = u[5].re;	u[5].re = u[5].im;	u[5].im = - d;
		    /* u[6] = - i * u[6] */
		    d = u[6].re;	u[6].re = u[6].im;	u[6].im = - d;
		    /* u[7] = -i sin(2/8) * u[7] */
		    d = u[7].re;	u[7].re = 0.70710678118654757 * u[7].im;	u[7].im = - 0.70710678118654757 * d;
		    /* s[1]s[4] ׻ */
		    s[1].re = u[3].re + u[4].re;	s[1].im = u[3].im + u[4].im;
		    s[2].re = u[3].re - u[4].re;	s[2].im = u[3].im - u[4].im;
		    s[3].re = u[6].re + u[7].re;	s[3].im = u[6].im + u[7].im;
		    s[4].re = u[6].re - u[7].re;	s[4].im = u[6].im - u[7].im;

		    bufd[b+i].re = u[0].re;			bufd[b+i].im = u[0].im;
		    bufd[b+i+4*p].re = u[1].re;			bufd[b+i+4*p].im = u[1].im;
		    bufd[b+i+6*p].re = u[2].re + u[5].re;	bufd[b+i+6*p].im = u[2].im + u[5].im;
		    bufd[b+i+2*p].re = u[2].re - u[5].re;	bufd[b+i+2*p].im = u[2].im - u[5].im;
		    bufd[b+i+7*p].re = s[1].re + s[3].re;	bufd[b+i+7*p].im = s[1].im + s[3].im;
		    bufd[b+i+3*p].re = s[2].re + s[4].re;	bufd[b+i+3*p].im = s[2].im + s[4].im;
		    bufd[b+i+5*p].re = s[2].re - s[4].re;	bufd[b+i+5*p].im = s[2].im - s[4].im;
		    bufd[b+i+p].re = s[1].re - s[3].re;		bufd[b+i+p].im = s[1].im - s[3].im;
		}
		b += 8 * p;
	    }
	    p *= 8;
	}

	for (k = 0 ; k < 1 ; k++) {	/* ʤο */
	    n /= 2; m /= 2; b = 0;
	    for (j = 0 ; j < m ; j++) {	/* ʤȢο */
		for (i = 0 ; i < p ; i++) {	/* Ȣȹ礻ο */
		    w = get_w(2*p,i);
		    z.re = w.re * y[b+i+p].re + w.im * y[b+i+p].im;
		    z.im = w.re * y[b+i+p].im - w.im * y[b+i+p].re;
		    X[b+i].re = y[b+i].re + z.re;
		    X[b+i].im = y[b+i].im + z.im;
		    X[b+i+p].re = y[b+i].re - z.re;
		    X[b+i+p].im = y[b+i].im - z.im;
		}
		b += 2 * p;
	    }
	    p *= 2;
	}

	vid = (cid % (NumberOfCell / 2)) * 2;
	if (cid >= NumberOfCell / 2) {
	    vid++;
	}

	/* N_PEĤΥǡȾʬ */
	q = NumberOfCell / 2;
	if ((int)(cid / q) % 2 == 0) {
	    MPI_Send(&X[N_PE/2],N_PE/2,MPI_DOUBLE,cid+q,0,MPI_COMM_WORLD);
	    MPI_Recv(&X[N_PE/2],N_PE/2,MPI_DOUBLE,cid+q,0,MPI_COMM_WORLD,&status);
	    MPI_Send(&X[N_PE*3/4],N_PE/2,MPI_DOUBLE,cid+q,0,MPI_COMM_WORLD);
	    MPI_Recv(&X[N_PE*3/4],N_PE/2,MPI_DOUBLE,cid+q,0,MPI_COMM_WORLD,&status);
	} else {
	    MPI_Send(X,N_PE/2,MPI_DOUBLE,cid-q,0,MPI_COMM_WORLD);
	    MPI_Recv(X,N_PE/2,MPI_DOUBLE,cid-q,0,MPI_COMM_WORLD,&status);
	    MPI_Send(&X[N_PE/4],N_PE/2,MPI_DOUBLE,cid-q,0,MPI_COMM_WORLD);
	    MPI_Recv(&X[N_PE/4],N_PE/2,MPI_DOUBLE,cid-q,0,MPI_COMM_WORLD,&status);
	}

	q = 1;
	for (k = 0 ; k < 7 ; k++) {		/* ʤο */
	    if (k % 2 == 1) {
		bufs = y; bufd = X;
	    } else {
		bufs = X; bufd = y;
	    }

	    b = (vid % (2*q)) * N_PE / 2;
	    for (i = 0 ; i < N_PE / 2 ; i++) {	/* PEȹ礻ο */
		w = get_w(2*p,b+i);
		z.re = w.re * bufs[i+N_PE/2].re + w.im * bufs[i+N_PE/2].im;
		z.im = w.re * bufs[i+N_PE/2].im - w.im * bufs[i+N_PE/2].re;
		bufd[i].re = bufs[i].re + z.re;
		bufd[i].im = bufs[i].im + z.im;
		bufd[i+N_PE/2].re = bufs[i].re - z.re;
		bufd[i+N_PE/2].im = bufs[i].im - z.im;
	    }


	    /* N_PEĤΥǡȾʬ */
	    if ((int)(cid / q) % 2 == 0) {
		MPI_Send(&bufd[N_PE/2],N_PE/2,MPI_DOUBLE,cid+q,0,MPI_COMM_WORLD);
		MPI_Recv(&bufd[N_PE/2],N_PE/2,MPI_DOUBLE,cid+q,0,MPI_COMM_WORLD,&status);
		MPI_Send(&bufd[N_PE*3/4],N_PE/2,MPI_DOUBLE,cid+q,0,MPI_COMM_WORLD);
		MPI_Recv(&bufd[N_PE*3/4],N_PE/2,MPI_DOUBLE,cid+q,0,MPI_COMM_WORLD,&status);
	    } else {
		MPI_Send(bufd,N_PE/2,MPI_DOUBLE,cid-q,0,MPI_COMM_WORLD);
		MPI_Recv(bufd,N_PE/2,MPI_DOUBLE,cid-q,0,MPI_COMM_WORLD,&status);
		MPI_Send(&bufd[N_PE/4],N_PE/2,MPI_DOUBLE,cid-q,0,MPI_COMM_WORLD);
		MPI_Recv(&bufd[N_PE/4],N_PE/2,MPI_DOUBLE,cid-q,0,MPI_COMM_WORLD,&status);
	    }

	    p *= 2;
	    q *= 2;
	}

	/* X <- y / N */
	for (i = 0 ; i < N_PE ; i++) {
	    X[i].re = y[i].re / (double)N;
	    X[i].im = y[i].im / (double)N;
	}

	/* Σ */
	t = 0.0;
	for (i = 0 ; i < N_PE ; i++) {
	    z.re = X[i].re - x[i].re;
	    z.im = X[i].im - x[i].im;
	    t += z.re * z.re + z.im * z.im;
	}
	MPI_Allreduce(&t,&sum,1,MPI_DOUBLE,MPI_SUM, MPI_COMM_WORLD);
	final(sum);

    free(W);
    free(y);
    free(x);
    free(X);
    free(ep);
}

complex get_w(int n, int p)
{
    complex z;
    int q;

    p = p % n;
    p *= N / n;
    q = p % (N/4);
    if (p < N/2) {
	if (p < N/4) {
	    z.re = W[N/4 - q];
	    z.im = - W[q];
	} else {
	    z.re = - W[q];
	    z.im = - W[N/4 - q];
	}
    } else {
	if (p < N*3/4) {
	    z.re = - W[N/4 - q];
	    z.im = W[q];
	} else {
	    z.re = W[q];
	    z.im = W[N/4 - q];
	}
    }
    return z;
}
